#{extends 'borderNG.html' /}
#{set 'titleHead'}
&{'lelang_doc.rincian_hps'}
#{/set}

<ol class="breadcrumb">
	<li><a href="@{BerandaCtr.index()}">&{'lelang_doc.home'}</a></li>
	<li><a href="@{lelang.LelangCtr.edit(lelang.lls_id)}">&{'lelang_doc.edit_tender'}</a></li>
	<li class="active">&{'lelang_doc.rincian_hps'}</li>
</ol>
<div class="content" id="hps-content">
	<div id="alert"></div>
#{if editable}
	<table id="template" class="table table-sm">
		<tr>
			<th><a href="#{assets '/documents/template-rincian.xlsx'/}" class="btn btn-default btn-sm"><i
						class="glyphicon glyphicon-download"></i> &{'lelang_doc.template_rincian_hps'}</a>
                <a class="btn btn-default btn-sm" href="#" onclick="$('#rincian_upload').click()" id="uploadHPS">&{'lelang_doc.upload_rincian_hps'}</a></th>
			<th><input type="file" id="rincian_upload" class="form-control" style="display:none"
			           placeholder="Upload Rincian HPS" #{if !editable} disabled #{/if}></th>
		</tr>
	</table>
		<div class="bs-callout bs-callout-info">
			<b>&{'lelang_doc.petunjuk_upload_hps'}</b><br/>
			&{'lelang_doc.petunjuk_upload_hps_1'}<br/>
			&{'lelang_doc.petunjuk_upload_hps_2'}
			<br/><br/>
			<b>&{'lelang_doc.petunjuk_upload_hps_3'}</b><br/>
			&{'lelang_doc.petunjuk_upload_hps_4'}<br/>
			&{'lelang_doc.petunjuk_upload_hps_5'}<br/>
			&{'lelang_doc.petunjuk_upload_hps_6'}
			<br /><br />
			&{'lelang_doc.petunjuk_pengisian_hps_table'}
		</div>
		<div class="clearfix"></div>
		<div class="bs-callout bs-callout-info">
			&{'lelang_doc.bulat_dua'}
		</div>
	#{/if}
	<table style="border:none; margin:20px;">
		<tr>
			<th style="text-align:right">&{'lelang_doc.total_pagu_caps'} :</th>
			<th id="total_hps" style="text-align:right">${lelang.paket.pkt_pagu.rupiah()}</th>
		</tr>
	</table>
	<div id="tbl-rincian" style="margin:20px; margin-bottom: 50px;"></div>
	<div class="float-right">
		<table id="rekap" class="table table-sm" style="width:300px;margin-right:170px;">
			<tr>
				<th style="text-align:right">&{'lelang_doc.total_nilai_caps'}</th>
				<th id="total_hps" style="text-align:right"></th>
			</tr>
		</table>
	</div>
	<div class="clearfix"></div>
#{if editable}
	#{authenticityToken /}
	<button type="button" name="simpan" id="simpan" class="btn btn-success"><i class="fa fa-save"></i> &{'lelang_doc.simpan'}</button>
#{/if}
<a href="@{lelang.LelangCtr.edit(lelang.lls_id)}" class="btn btn-default btn-sm"><i class="fa fa-arrow-circle-left fa-fw"></i> &{'lelang_doc.kembali'}</a>
</div>

#{set 'css_custom' }
	#{if editable}
		<link href="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/css/jquery.fileupload.min.css" rel="stylesheet" type="text/css">
	#{/if}
	<link href="#{assets '/handsontable/handsontable.full.min.css'/}" rel="stylesheet" type="text/css">
#{/set}


#{set 'custom_script'}
	#{if editable}
	<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/vendor/jquery.ui.widget.min.js"></script>
	<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.iframe-transport.min.js"></script>
	<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload.min.js"></script>
	<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload-process.min.js"></script>
	<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload-validate.min.js"></script>
	#{/if}
<script type="text/javascript" src="#{assets '/handsontable/handsontable.full.min.js'/}"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/PapaParse/5.1.0/papaparse.min.js"></script>
<script type="text/javascript" src="https://unpkg.com/xlsx@0.15.6/dist/jszip.js"></script>
<script type="text/javascript" src="https://unpkg.com/xlsx@0.15.6/dist/xlsx.min.js"></script>

<script type="text/javascript">
	var data = ${data?.raw()};
	var interval = 2 * 60 * 1000; // 2 menit
	var total_dkh = #{if total > 0} ${total} #{/if} #{else} 0 #{/else};
	var fixed = true;
	var enableViewHps = ${enableViewHps};
	var X = XLSX;
	var firstLoad = true;

	$(document).on('change', '#rincian_upload', function (e) {
		var files = e.target.files;
		var f = files[0];
		{
			var reader = new FileReader();
			var name = f.name;
			reader.onload = function (e) {
				var data = e.target.result;
				try {
					var wb = X.read(data, {type: 'binary'});
					process_wb(wb);
				} catch (err) {
					console.log(err);
					alert("Format file HPS yang Anda upload tidak valid.");
				}
			};
			reader.readAsBinaryString(f);
		}
	});

	function process_wb(wb) {
		var output = to_json(wb);
		var res = output['rincian-hps'];
		var obj = new Array();
		var invalid_rows = new Array();
		for (i = 0; i < res.length; i++) {
			var totalharga = 0;
			var totalpajak = 0;

			var item = replaceChar(res[i]['Jenis Barang/Jasa']);
			var unit = replaceChar(res[i]['Satuan']);
			var vol = res[i]['Vol'];
			var harga = res[i]['Harga'];
			var pajak = res[i]['Pajak(%)'];
			//var total_harga = totalharga;
			var keterangan = replaceChar(res[i]['Keterangan']);

			if (!parseInt(harga, 10)) {
				harga = 0;
			}

			if (!parseFloat(vol)) {
				vol = 0;
			} else {
				totalharga = vol * harga;
			}

			//pajak ga boleh null
			if (!parseInt(pajak, 10)) {
				pajak = 0;
			}
			if (pajak > 0) {
				totalpajak = (pajak / 100) * totalharga;
				totalharga += totalpajak;
			}

			if (isNaN(totalharga)) {
				invalid_rows.push(i+1);
				totalharga=0;
			}

			obj.push({
				item: item,
				unit: unit,
				vol: vol,
				harga: harga,
				pajak: pajak,
				//asep:total to auto
				//total_harga:res[i][7],
				total_harga: totalharga,
				keterangan: keterangan
			})

		}
		if (invalid_rows.length > 0) {
			$('#alert').html('<div class="alert alert-danger">&{'paket.invalid_input_number_pada_baris'}  ' + formatArray(invalid_rows) + '. Mohon periksa kembali inputan Anda!</div>');
		}
		data = obj;
		$("#tbl-rincian").handsontable("loadData", obj);
		summary();
	}

	function formatArray(arr) {
		var outStr = "";
		if (arr.length === 1) {
			outStr = arr[0];
		} else if (arr.length === 2) {
			outStr = arr.join(" dan ");
		} else if (arr.length > 2) {
			outStr = arr.slice(0, -1).join(", ") + ", dan " + arr.slice(-1);
		}
		return outStr;
	}

	function to_json(workbook) {
		var result = {};
		workbook.SheetNames.forEach(function (sheetName) {
			var roa = X.utils.sheet_to_row_object_array(workbook.Sheets[sheetName]);
			if (roa.length > 0) {
				result[sheetName] = roa;
			}
		});
		return result;
	}
	function replaceChar(str) {
		var strs = "";
		if (str != undefined)
			strs += str;

		return strs.replace(/[^a-zA-Z0-9.,!@#$%&@*()-+=/\-\s ]/g, "");
	}

	if (data.length == 0) {
        for(var i=0;i<15;i++){
            data.push({item: "",unit: "",vol: 1,unit2: "",vol2: 1,harga: 0,pajak: 10,total_harga: 0,keterangan: ""});
        }
    }

	var language = {
		delimiters: {
			thousands: '.',
			decimal: ','
		},
		abbreviations: {
			thousand: 'rb',
			million: 'jt',
			billion: 'M',
			trillion: 'B'
		},
		ordinal: function (number) {
			var b = number % 10;
			return (~~(number % 100 / 10) ===1) ? 'th' : (b === 1) ? 'st' : (b === 2) ? 'nd' : (b === 3) ? 'rd' : 'th';
		},
		currency: {
			symbol: 'Rp.'
		}
	};

	// Node
	if (typeof module !== 'undefined' && module.exports) {
		module.exports = language;
	}

	// Browser
	if (typeof window !== 'undefined' && this.numeral && this.numeral.language) {
		this.numeral.language('id', language);
	}

	$("#tbl-rincian").handsontable({
		rowHeaders: true,
		dataSchema: {
			item: "",
			unit: "",
			vol: 1,
			unit2: "",
			vol2: 1,
			harga: 0,
			pajak: 10,
			total_harga: 0,
			keterangan: ""
		},
		data: data,
		#{if editable}
			contextMenu: {
				callback:function(key, row, col, options){
					if(key==='make_read_only'){
						console.log("row : " + row);
						console.log("col : " + col);
						// todo: buat implementasi read only di sini
					}
				},
				items: {
					"row_above": {name: "&{'paket.tambah_baris_diatas'}"},
					"row_below": {name: "&{'paket.tambah_baris_dibawah'}"},
					"remove_row": {name: "&{'paket.hapus_baris'}"},
					"undo": {name: "&{'paket.undo'}"},
					"redo": {name: "&{'paket.redo'}"}//,
                    //"make_read_only" : {name: "Buat Baris Terkunci"}
				}
			},
			fillHandle: true,
		#{/if}
		#{else}
			fillHandle: false,
		#{/else}
		language: 'id',
		columns: [{data: 'item', width: 200, title: '&{'paket.jenis_barang_jasa'}'},
			{data: 'unit', width: 100, title: '&{'paket.satuan'}'},
			{data: 'vol', type: 'numeric', format: '0,0.00', width: 50, title: '&{'paket.vol'}', allowInvalid: false},
			// {data: 'unit2', width: 100, title: 'Satuan 2', allowInvalid: false},
			// {data: 'vol2', type: 'numeric', format: '0,0.00', width: 50, title: 'Vol 2', allowInvalid: false},
			{data: 'harga', type: 'numeric', format: '0,0.00', width: 100, title: '&{'paket.harga'}', allowInvalid: false},
			{data: 'pajak', type: 'numeric', format: '0,0.00', width: 60, title: '&{'paket.pajak'}(%)', dataSchema: 10, allowInvalid: false},
			{data: 'total_harga', type: 'numeric', format: '0,0.00', width: 100, title: '&{'paket.total'}', allowInvalid: false},
			{data: 'keterangan', width: 250, title: 'Keterangan'}],
		cells: function (row, col, prop) {
			var cellProperties = {};
			#{if editable}
				if (col == 5) {
					cellProperties.readOnly = true;
				}
				if (data[row] && (col == 2 || col == 3 || col == 4)) {
					var total = 0;
					var strs = "";
					if (data[row].vol <= 0)
						data[row].vol = 1.0;
					if (data[row].harga > 0)
						total = data[row].harga;
					if (data[row].vol > 0) {
						data[row].vol = rounded2Decimal(parseFloat(data[row].vol));
						total = total * data[row].vol;
					}
					if (data[row].pajak > 0)
						total = total + ((total * data[row].pajak) / 100);
					else
                        data[row].pajak = 0;
					if (total >= 0) {
						data[row].total_harga = rounded2Decimal(total2);
					}
				}
				if (data[row] && (col == 1 || col == 2 || col == 6)) {
					data[row].item = replaceChar(data[row].item);
					data[row].unit = replaceChar(data[row].unit);
					data[row].keterangan = replaceChar(data[row].keterangan);
				}
			#{/if}
			#{else}
				cellProperties.readOnly = true;
			#{/else}
			return cellProperties;
		},
		afterChange: function (change, source) {
			summary();
		},
		afterRemoveRow: function () {
			summary();
		}
	});

	function summary() {
		if(firstLoad) {
			$("#rekap").find("#total_hps").text(toRupiah(rounded2Decimal(total_dkh)));
			firstLoad = false;
		} else {
			var data = $("#tbl-rincian").data('handsontable').getData();
			var total_hps = 0;
			var total = 0;
			for (i = 0; i < data.length; i++) {
				if (data[i].total_harga)
					total += parseFloat(data[i].total_harga);
			}
			if (total > 0) {
				total_hps = parseFloat(total);
			}
			$("#rekap").find("#total_hps").text(toRupiah(rounded2Decimal(total_hps)));
		}
	}

	$("#fixed").on('change', function () {
		fixed = this.checked ? false : true;
	});
	$("#enableViewHps").on('change', function () {
		enableViewHps = $(this).is(":checked") ? true : false;
	});

		#{if editable}
		$("#simpan").click(function () {
			autosave();
			$('html, body').animate({scrollTop: $('#hps-content').offset().top}, 'fast'); //go to alert
		});
		function autosave() {
			var postdata = $("#tbl-rincian").data('handsontable').getData();
			var token = $("input[name='authenticityToken']").val();
			$.ajax({
				url: '@{lelang.DokumenCtr.hpsSubmit(lelang?.lls_id)}',
				data: {"data": JSON.stringify(postdata),"fixed": fixed,"enableViewHps": enableViewHps,"authenticityToken": token},
				type: 'POST',
				success: function (res) {
					if (res.result === 'ok')
						$('#alert').html('<div class="alert alert-success">Data berhasil tersimpan</div>');
					else if (res.result.length > 0)
						$('#alert').html('<div class="alert alert-danger">' + res.result + '</div>');
					else
						$('#alert').html('<div class="alert alert-danger">Data gagal tersimpan, mohon periksa kembali inputan Anda</div>');
				},
				error: function () {
					$('#alert').html('<div class="alert alert-danger">Data gagal tersimpan karena ada kendala jaringan/server</div>');
				}
			});
		}
		setInterval(autosave, interval);
		#{/if}
</script>
#{/set}